'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _Module = require('../Module');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _react3.storiesOf)('Module', module).addWithInfo('Single', '\n      Modules are used to organize content in a structural manner.\n\n\n      Modules are separated into different components. Module components can be\n      \'single\' or \'double\' with the default as \'double\'.\n\n\n      ModuleHeader and ModuleBody components hold the content of the\n      Module\n    ', function () {
  return _react2.default.createElement(
    _Module.Module,
    { className: 'some-class', size: 'single' },
    _react2.default.createElement(
      _Module.ModuleHeader,
      null,
      'Module Example'
    ),
    _react2.default.createElement(
      _Module.ModuleBody,
      null,
      _react2.default.createElement(
        'p',
        null,
        'Lorem Ipsum is dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry\'s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book.'
      ),
      _react2.default.createElement(
        'p',
        null,
        'It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged.'
      )
    )
  );
}).addWithInfo('Double', '\n      Modules are used to organize content in a structural manner.\n\n      Modules are separated into different components. Module components can be\n      \'single\' or \'double\' with the default as \'double\'.\n\n      ModuleHeader and ModuleBody components hold the content of the\n      Module\n    ', function () {
  return _react2.default.createElement(
    _Module.Module,
    { className: 'some-class' },
    _react2.default.createElement(
      _Module.ModuleHeader,
      null,
      'Module Example'
    ),
    _react2.default.createElement(
      _Module.ModuleBody,
      null,
      _react2.default.createElement(
        'p',
        null,
        'Lorem Ipsum is dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry\'s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book.'
      ),
      _react2.default.createElement(
        'p',
        null,
        'It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged.'
      )
    )
  );
}).addWithInfo('No Header', '\n      Modules are used to organize content in a structural manner.\n\n      Modules are separated into different components. Module components can be\n      \'single\' or \'double\' with the default as \'double\'.\n\n      ModuleHeader and ModuleBody components hold the content of the\n      Module\n    ', function () {
  return _react2.default.createElement(
    _Module.Module,
    { className: 'some-class', size: 'single' },
    _react2.default.createElement(
      _Module.ModuleBody,
      null,
      _react2.default.createElement(
        'p',
        null,
        'It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged.'
      )
    )
  );
}).addWithInfo('No Header - Centered Content', '\n      Modules are used to organize content in a structural manner.\n\n      Modules are separated into different components. Module components can be\n      \'single\' or \'double\' with the default as \'double\'.\n\n      ModuleHeader and ModuleBody components hold the content of the\n      Module\n    ', function () {
  return _react2.default.createElement(
    _Module.Module,
    { className: 'some-class', size: 'single' },
    _react2.default.createElement(
      _Module.ModuleBody,
      { centered: true },
      _react2.default.createElement(
        'p',
        null,
        'Lorem Ipsum is dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry\'s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book.'
      ),
      _react2.default.createElement(
        'p',
        null,
        'It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged.'
      )
    )
  );
});