'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _StructuredList = require('../StructuredList');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _react3.storiesOf)('StructuredList', module).addWithInfo('Simple', '\n      description here\n    ', function () {
  return _react2.default.createElement(
    _StructuredList.StructuredListWrapper,
    null,
    _react2.default.createElement(
      _StructuredList.StructuredListHead,
      null,
      _react2.default.createElement(
        _StructuredList.StructuredListRow,
        { head: true },
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          { head: true },
          'ColumnA'
        ),
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          { head: true },
          'ColumnB'
        ),
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          { head: true },
          'ColumnC'
        )
      )
    ),
    _react2.default.createElement(
      _StructuredList.StructuredListBody,
      null,
      _react2.default.createElement(
        _StructuredList.StructuredListRow,
        null,
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          { noWrap: true },
          'Row 1'
        ),
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          null,
          'Row 1'
        ),
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          null,
          'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nunc dui magna, finibus id tortor sed, aliquet bibendum augue. Aenean posuere sem vel euismod dignissim. Nulla ut cursus dolor. Pellentesque vulputate nisl a porttitor interdum.'
        )
      ),
      _react2.default.createElement(
        _StructuredList.StructuredListRow,
        null,
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          { noWrap: true },
          'Row 2'
        ),
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          null,
          'Row 2'
        ),
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          null,
          'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nunc dui magna, finibus id tortor sed, aliquet bibendum augue. Aenean posuere sem vel euismod dignissim. Nulla ut cursus dolor. Pellentesque vulputate nisl a porttitor interdum.'
        )
      )
    )
  );
}).addWithInfo('Selection', '\n      description here\n    ', function () {
  return _react2.default.createElement(
    _StructuredList.StructuredListWrapper,
    { selection: true, border: true },
    _react2.default.createElement(
      _StructuredList.StructuredListHead,
      null,
      _react2.default.createElement(
        _StructuredList.StructuredListRow,
        { head: true },
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          { head: true },
          ''
        ),
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          { head: true },
          'ColumnA'
        ),
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          { head: true },
          'ColumnB'
        ),
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          { head: true },
          'ColumnC'
        )
      )
    ),
    _react2.default.createElement(
      _StructuredList.StructuredListBody,
      null,
      _react2.default.createElement(
        _StructuredList.StructuredListRow,
        { label: true, htmlFor: 'Row 1' },
        _react2.default.createElement(_StructuredList.StructuredListInput, {
          id: 'row-1',
          value: 'row-2',
          title: 'row-3',
          name: 'Row-1',
          defaultChecked: true
        }),
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          null,
          _react2.default.createElement(_Icon2.default, {
            className: 'bx--structured-list-svg',
            name: 'checkmark--glyph',
            description: 'select an option'
          })
        ),
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          null,
          'Row 1'
        ),
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          null,
          'Row 1'
        ),
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          null,
          'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nunc dui magna, finibus id tortor sed, aliquet bibendum augue. Aenean posuere sem vel euismod dignissim. Nulla ut cursus dolor. Pellentesque vulputate nisl a porttitor interdum.'
        )
      ),
      _react2.default.createElement(
        _StructuredList.StructuredListRow,
        { label: true, htmlFor: 'Row2' },
        _react2.default.createElement(_StructuredList.StructuredListInput, {
          id: 'row-2',
          value: 'row-2',
          title: 'row-2',
          name: 'row-2'
        }),
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          null,
          _react2.default.createElement(_Icon2.default, {
            className: 'bx--structured-list-svg',
            name: 'checkmark--glyph',
            description: 'select an option'
          })
        ),
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          null,
          'Row 2'
        ),
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          null,
          'Row 2'
        ),
        _react2.default.createElement(
          _StructuredList.StructuredListCell,
          null,
          'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nunc dui magna, finibus id tortor sed, aliquet bibendum augue. Aenean posuere sem vel euismod dignissim. Nulla ut cursus dolor. Pellentesque vulputate nisl a porttitor interdum.'
        )
      )
    )
  );
});